var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import invariant from 'ts-tiny-invariant';
import { NativeComponent } from './native-component';
import { styles } from './styles';
import { View, StyleSheet } from 'react-native';
import { processTextStyle } from './process-text-style';
const RefComponent = (props, forwardedRef) => {
    const { values = [], selectedIndices = [], minSelected = 0, maxSelected = 0, enabled = true, style, textStyle, selectedTextStyle = textStyle, tintColor, onChange, hideDivider, dividerColor } = props, restProps = __rest(props, ["values", "selectedIndices", "minSelected", "maxSelected", "enabled", "style", "textStyle", "selectedTextStyle", "tintColor", "onChange", "hideDivider", "dividerColor"]);
    invariant(minSelected === 0 || values.length >= minSelected, `length of 'values' (${values.length}) should be greater or ` +
        `equal to 'minSelected' (${minSelected})`);
    invariant(minSelected === 0 || selectedIndices.length >= minSelected, `length of 'selectedIndices' (${selectedIndices.length}) should be greater or ` +
        `equal to 'minSelected' (${minSelected})`);
    invariant(maxSelected === 0 || selectedIndices.length <= maxSelected, `length of 'selectedIndices' (${selectedIndices.length}) should be less or ` +
        `equal to 'maxSelected' (${maxSelected})`);
    const _a = StyleSheet.flatten(style) || {}, { borderRadius, borderWidth, backgroundColor, elevation } = _a, rest = __rest(_a, ["borderRadius", "borderWidth", "backgroundColor", "elevation"]);
    return (<View {...restProps} style={[styles.container, rest]}>
      <NativeComponent tintColor={tintColor} onChange={onChange} hideDivider={hideDivider} dividerColor={dividerColor} key={values.join()} values={values} selectedIndices={selectedIndices} minSelected={minSelected} maxSelected={maxSelected} enabled={enabled} style={styles.control} borderRadius={borderRadius} borderWidth={borderWidth} backgroundColor={backgroundColor} textStyle={processTextStyle(textStyle)} selectedTextStyle={processTextStyle(selectedTextStyle)} elevation={elevation} ref={forwardedRef}/>
    </View>);
};
export const Component = React.forwardRef(RefComponent);
Component.displayName = 'MultiSegmentedControl';
//# sourceMappingURL=multi-segmented-control.js.map